%define _sysconfdir /etc

Summary: A collection of basic system utilities.
Name: util-linux
Version: 2.10q
Release: 1.0.9
Copyright: distributable
Group: System Environment/Base
Provides: util-linux
Source0: ftp://ftp.kernel.org/pub/linux/utils/util-linux/util-linux-%{version}.tar.gz
Source1: util-linux-GD-login.pamd 
Source2: util-linux-2.9w-kbdrate.pamd
Source3: util-linux-2.9w-kbdrate.apps
Patch0: util-linux-2.10q-master.patch

%ifarch sparc alpha
Obsoletes: clock
%endif
%ifarch alpha
Conflicts: initscripts <= 4.58, timeconfig <= 3.0.1
%endif
BuildRoot: %{_tmppath}/%{name}-root
Requires: pam >= 0.72-1.0.1, kernel >= 2.2.17

%description
The util-linux package contains a large variety of low-level system
utilities that are necessary for a Linux system to function.  Among
many features, Util-linux contains the fdisk configuration tool and
the login program.

%prep

%setup -q

%patch0 -p1

%build
unset LINGUAS || :
./configure
make "RPM_OPT_FLAGS=$RPM_OPT_FLAGS" 

cd rescuept
gcc $RPM_OPT_FLAGS -o rescuept rescuept.c
cd ..

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{bin,etc/pam.d,sbin}
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/lib
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man{1,6,8}
mkdir -p $RPM_BUILD_ROOT/%{_infodir}
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/{cs,de,fr,it,ja,nl,pt_BR}/LC_MESSAGES
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/security/console.apps
mkdir -p -m 0750 $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d

make install DESTDIR=$RPM_BUILD_ROOT

install -m 755 rescuept/rescuept ${RPM_BUILD_ROOT}/sbin

gzip -9nf $RPM_BUILD_ROOT/%{_infodir}/ipc.info

strip $RPM_BUILD_ROOT/bin/login
strip $RPM_BUILD_ROOT/sbin/fdisk

install -m 660 ${RPM_SOURCE_DIR}/util-linux-GD-login.pamd \
	$RPM_BUILD_ROOT/%{_sysconfdir}/pam.d/login
install -m 660 ${RPM_SOURCE_DIR}/util-linux-2.9w-kbdrate.pamd \
	$RPM_BUILD_ROOT/%{_sysconfdir}/pam.d/kbdrate
install -m 660 ${RPM_SOURCE_DIR}/util-linux-2.9w-kbdrate.apps \
	$RPM_BUILD_ROOT/%{_sysconfdir}/security/console.apps/kbdrate
(cd $RPM_BUILD_ROOT/usr/bin ; ln -s consolehelper kbdrate)

rm -f $RPM_BUILD_ROOT/sbin/clock
ln -s hwclock $RPM_BUILD_ROOT/sbin/clock

# We do not want dependencies on csh
chmod 644 $RPM_BUILD_ROOT/usr/share/misc/getopt/*

%clean
## [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_prefix}/share/locale/*/LC_MESSAGES/*

/sbin/clock
%attr(0750,root,root)	/sbin/hwclock
%doc %{_mandir}/man8/hwclock.8*

%attr(0660,root,admin) %config %{_sysconfdir}/pam.d/login

%attr(0660,root,admin) %config %{_sysconfdir}/pam.d/kbdrate
%attr(0660,root,admin) %config %{_sysconfdir}/security/console.apps/kbdrate
/usr/bin/kbdrate

%attr(0750,root,root)	/sbin/fdisk

%ifarch i386 i486 i586 i686 alpha armv4l
%attr(0750,root,root)	/sbin/cfdisk
%endif

%ifarch i386 i486 i586 i686 alpha
%attr(0750,root,root)	/sbin/fsck.minix
%attr(0750,root,root)	/sbin/mkfs.minix
%endif

/usr/bin/raw
%doc %{_mandir}/man8/raw.8*

%attr(0750,root,root)	/sbin/mkfs
%attr(0750,root,root)	/sbin/mkswap

/usr/bin/fdformat
/usr/bin/setfdprm
%config /etc/fdprm

%doc %{_mandir}/man8/fdformat.8*
%doc %{_mandir}/man8/mkswap.8*
%doc %{_mandir}/man8/setfdprm.8*

%ifarch i386 i486 i586 i686 alpha sparc
%attr(755,root,root)	/bin/login
%attr(0750,root,admin)	/usr/sbin/vipw
%attr(0750,root,admin)	/usr/sbin/vigr
%doc %{_mandir}/man1/login.1*
%doc %{_mandir}/man8/vipw.8*
%doc %{_mandir}/man8/vigr.8*
%endif

/bin/kill
/usr/bin/cal
%ifarch sparc
/usr/bin/sunhostid
%endif
%attr(0750,root,root)	/usr/bin/logger
/usr/bin/look
/usr/bin/mcookie
/usr/bin/namei
/usr/bin/script
/usr/bin/setterm
/usr/bin/whereis
%attr(0755,root,tty)	/usr/bin/write
/usr/bin/getopt
%doc %{_mandir}/man1/cal.1*
%doc %{_mandir}/man1/kill.1*
%doc %{_mandir}/man1/logger.1*
%doc %{_mandir}/man1/look.1*
%doc %{_mandir}/man1/mcookie.1*
%doc %{_mandir}/man1/namei.1*
%doc %{_mandir}/man1/script.1*
%doc %{_mandir}/man1/setterm.1*
%doc %{_mandir}/man1/whereis.1*
%doc %{_mandir}/man1/write.1*
%doc %{_mandir}/man1/getopt.1*

/usr/share/misc/getopt

/bin/dmesg

%attr(0711,root,root)	/sbin/ctrlaltdel
/sbin/kbdrate
/bin/arch
%attr(0750,root,root)	/usr/bin/ipcrm
%attr(0750,root,root)	/usr/bin/ipcs
%attr(0750,root,root)	/usr/bin/renice
/usr/bin/setsid
%ifarch i386 i486 i586 i686 alpha armv4l
/usr/bin/cytune
%endif

%doc %{_mandir}/man1/arch.1*
%ifarch i386 i486 i586 i686 alpha armv4l
%doc %{_mandir}/man8/cytune.8*
%endif
%doc %{_mandir}/man8/ctrlaltdel.8*
%doc %{_mandir}/man8/dmesg.8*
%doc %{_mandir}/man8/ipcrm.8*
%doc %{_mandir}/man8/ipcs.8*
%doc %{_mandir}/man8/kbdrate.8*
%doc %{_mandir}/man8/renice.8*
%doc %{_mandir}/man8/setsid.8*

%ifarch i386 i486 i586 i686
%attr(0750,root,root) /usr/sbin/rdev
/usr/sbin/ramsize
/usr/sbin/rootflags
/usr/sbin/swapdev
/usr/sbin/vidmode
%doc %{_mandir}/man8/rdev.8*
%doc %{_mandir}/man8/ramsize.8*
%doc %{_mandir}/man8/rootflags.8*
%doc %{_mandir}/man8/swapdev.8*
%doc %{_mandir}/man8/vidmode.8*
%endif

%{_infodir}/ipc.info.gz

/usr/bin/col
/usr/bin/colcrt
/usr/bin/colrm
/usr/bin/column
/usr/bin/hexdump
/usr/bin/rename
/usr/bin/rev
/usr/bin/ul

%doc %{_mandir}/man1/col.1*
%doc %{_mandir}/man1/colcrt.1*
%doc %{_mandir}/man1/colrm.1*
%doc %{_mandir}/man1/column.1*
%doc %{_mandir}/man1/hexdump.1*
%doc %{_mandir}/man1/rename.1*
%doc %{_mandir}/man1/rev.1*
%doc %{_mandir}/man1/ul.1*

/bin/more
%doc %{_mandir}/man1/more.1*
/usr/share/misc/more.help

%ifarch i386 i486 i586 i686 alpha
%doc %{_mandir}/man8/fsck.minix.8*
%doc %{_mandir}/man8/mkfs.minix.8*
%doc %{_mandir}/man8/mkfs.8*
%endif

%doc %{_mandir}/man8/fdisk.8*

%ifarch i386 i486 i586 i686 alpha armv4l
%doc %{_mandir}/man8/cfdisk.8*
%endif

%doc */README.*

%ifarch i386 i486 i586 i686 alpha
%attr(0750,root,root)	/sbin/sfdisk
%doc %{_mandir}/man8/sfdisk.8*
%doc fdisk/sfdisk.examples
%endif

%changelog
* Mon Mar 26 2001 Pete O'Hara <pete@guardiandigital.com>
- removed HAVE_SLANG=yes in master patch to compile
	cfdisk without slang libraries

* Mon Mar 26 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.10q, Release 1.0.8
  - Added slang Requirement.


* Thu Feb 15 2001 Pete O'Hara <pete@guardiandigital.com>
- changed Requires: kernel >=2.2.17-xxx to just 2.2.17

* Sun Dec 03 2000 Dave Wreski <dave@guardiandigital.com>
- added Provides: util-linux

* Wed Nov 21 2000 Pete O'Hara <pete@guardiandigital.com>
- created a new /etc/pam.d/login file for EnGarde
- fixed "ifarch" that only specified i386 to include
        i(456)86

* Fri Nov 17 2000 Dave Wreski <dave@guardiandigital.com>
- upgraded to 2.10q (2.4-test, security improvements)
- updated patches
- removed /usr/local from default path
- disk-utils/raw.c: changed <linux/raw.h> to <sys/raw.h>
- fix broken getopt path (change to /usr/share/misc/getopt)
- fix broken more.help path (change to /usr/share/misc/more.help)
- fix permissions on pam files

* Sat Oct 28 2000 Dave Wreski <dave@guardiandigital.com>
- Included RH rescuept tool
- FHS support
- added RH patches
- removed banner

* Mon Sep 18 2000 Pete O'Hara <pete@guardiandigital.com>
- removed NFS support - kept the patches in for future
	turning support back on 

* Wed Aug 23 2000 Pete O'Hara <pete@guardiandigital.com>
- removed world access to /usr/bin/logger
- removed /usr/bin/chsh, chfn - using the ones in shadow-utils

* Wed Jul 5 2000 Pete O'Hara <pete@guardiandigital.com>
- removed "nullok" from pam.d/login config file
- removed suid and world access to /usr/bin/chsh, chfn
- removed newgrp from rpm
- removed sgid from /bin/write
- changed /etc/pam.d/login in conjunction with new
	pam_access module to deny console login to 	
	everyone but root

* Tue Mar  7 2000 Jeff Johnson <jbj@redhat.com>
- rebuild for sparc baud rates > 38400.

* Sat Mar  4 2000 Matt Wilson <msw@redhat.com>
- use snprintf - not sprintf - when doing
  sprintf ("%s\n", _("Some string")) to avoid overflows and
  segfaults.

* Mon Feb 21 2000 Jeff Johnson <jbj@redhat.com>
- raw control file was /dev/raw, now /dev/rawctl.
- raw access files were /dev/raw*, now /dev/raw/raw*.

* Thu Feb 17 2000 Erik Troan <ewt@redhat.com>
- -v argument to mkswap wasn't working

* Thu Feb 10 2000 Jakub Jelinek <jakub@redhat.com>
- Recognize 0xfd on Sun disklabels as RAID

* Tue Feb  8 2000 Bill Nottingham <notting@redhat.com>
- more lives in /bin, and was linked against /usr/lib/libnurses. Bad.

* Thu Feb 03 2000 Jakub Jelinek <jakub@redhat.com>
- update to 2.10f
- fix issues in the new realpath code, avoid leaking memory

* Tue Feb 01 2000 Cristian Gafton <gafton@redhat.com>
- rebuild to fix dependencies
- add NFSv3 patches

* Fri Jan 28 2000 Bill Nottingham <notting@redhat.com>
- don't require csh

* Mon Jan 24 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.10e
- add rename

* Thu Jan 20 2000 Jeff Johnson <jbj@redhat.com>
- strip newlines in logger input.

* Mon Jan 10 2000 Jeff Johnson <jbj@redhat.com>
- rebuild with correct ncurses libs.

* Tue Dec  7 1999 Matt Wilson <msw@redhat.com>
- updated to util-linux 2.10c
- deprecated IMAP login mail notification patch17
- deprecated raw patch22
- depricated readprofile patch24

* Tue Dec  7 1999 Bill Nottingham <notting@redhat.com>
- add patch for readprofile

* Thu Nov 18 1999 Michael K. Johnson <johnsonm@redhat.com>
- tunelp should come from util-linux

* Tue Nov  9 1999 Jakub Jelinek <jakub@redhat.com>
- kbdrate cannot use /dev/port on sparc.

* Wed Nov  3 1999 Jakub Jelinek <jakub@redhat.com>
- fix kbdrate on sparc.

* Wed Oct 27 1999 Bill Nottingham <notting@redhat.com>
- ship hwclock on alpha.

* Tue Oct  5 1999 Bill Nottingham <notting@redhat.com>
- don't ship symlinks to rdev if we don't ship rdev.

* Tue Sep 07 1999 Cristian Gafton <gafton@redhat.com>
- add rawIO support from sct

* Mon Aug 30 1999 Preston Brown <pbrown@redhat.com>
- don't display "new mail" message when the only piece of mail is from IMAP

* Fri Aug 27 1999 Michael K. Johnson <johnsonm@redhat.com>
- kbdrate is now a console program

* Thu Aug 26 1999 Jeff Johnson <jbj@redhat.com>
- hostid is now in sh-utils. On sparc, install hostid as sunhostid (#4581).
- update to 2.9w:
-  Updated mount.8 (Yann Droneaud)
-  Improved makefiles
-  Fixed flaw in fdisk

* Tue Aug 10 1999 Jeff Johnson <jbj@redhat.com>
- tsort is now in textutils.

* Wed Aug  4 1999 Bill Nottingham <notting@redhat.com>
- turn off setuid bit on login. Again. :(

* Tue Aug  3 1999 Peter Jones, <pjones@redhat.com>
- hostid script for sparc (#3803).

* Tue Aug 03 1999 Christian 'Dr. Disk' Hechelmann <drdisk@tc-gruppe.de>
- added locale message catalogs to %file
- added patch for non-root build
- vigr.8 and /usr/lib/getopt  man-page was missing from file list
- /etc/fdprm really is a config file

* Fri Jul 23 1999 Jeff Johnson <jbj@redhat.com>
- update to 2.9v:
-   cfdisk no longer believes the kernel's HDGETGEO
    (and may be able to partition a 2 TB disk)

* Fri Jul 16 1999 Jeff Johnson <jbj@redhat.com>
- update to 2.9u:
-   Czech more.help and messages (Ji Pavlovsk)
-   Japanese messages (Daisuke Yamashita)
-   fdisk fix (Klaus G. Wagner)
-   mount fix (Hirokazu Takahashi)
-   agetty: enable hardware flow control (Thorsten Kranzkowski)
-   minor cfdisk improvements
-   fdisk no longer accepts a default device
-   Makefile fix

* Tue Jul  6 1999 Jeff Johnson <jbj@redhat.com>
- update to 2.9t:
-   national language support for hwclock
-   Japanese messages (both by Daisuke Yamashita)
-   German messages and some misc i18n fixes (Elrond)
-   Czech messages (Ji Pavlovsk)
-   wall fixed for /dev/pts/xx ttys
-   make last and wall use getutent() (Sascha Schumann)
    [Maybe this is bad: last reading all of wtmp may be too slow.
     Revert in case people complain.]
-   documented UUID= and LABEL= in fstab.5
-   added some partition types
-   swapon: warn only if verbose

* Fri Jun 25 1999 Jeff Johnson <jbj@redhat.com>
- update to 2.9s.

* Sat May 29 1999 Jeff Johnson <jbj@redhat.com>
- fix mkswap sets incorrect bits on sparc64 (#3140).

* Thu Apr 15 1999 Jeff Johnson <jbj@redhat.com>
- on sparc64 random ioctls on clock interface cause kernel messages.

* Thu Apr 15 1999 Jeff Johnson <jbj@redhat.com>
- improved raid patch (H.J. Lu).

* Wed Apr 14 1999 Michael K. Johnson <johnsonm@redhat.com>
- added patch for smartraid controllers

* Sat Apr 10 1999 Cristian Gafton <gafton@redhat.com>
- fix logging problems caused by setproctitle and PAM interaction
  (#2045)

* Wed Mar 31 1999 Jeff Johnson <jbj@redhat.com>
- include docs and examples for sfdisk (#1164)

* Mon Mar 29 1999 Matt Wilson <msw@redhat.com>
- rtc is not working properly on alpha, we can't use hwclock yet.

* Fri Mar 26 1999 Cristian Gafton <gafton@redhat.com>
- add patch to make mkswap more 64 bit friendly... Patch from
  eranian@hpl.hp.com (ahem!)

* Thu Mar 25 1999 Jeff Johnson <jbj@redhat.com>
- include sfdisk (#1164)
- fix write (#1784)
- use positive logic in spec file (%ifarch rather than %ifnarch).
- (re)-use 1st matching utmp slot if search by mypid not found.
- update to 2.9o
- lastb wants bad logins in wtmp clone /var/run/btmp (#884)

* Thu Mar 25 1999 Jakub Jelinek <jj@ultra.linux.cz>
- if hwclock is to be compiled on sparc,
  it must actually work. Also, it should obsolete
  clock, otherwise it clashes.
- limit the swap size in mkswap for 2.2.1+ kernels
  by the actual maximum size kernel can handle.
- fix kbdrate on sparc, patch by J. S. Connell
  <ankh@canuck.gen.nz>

* Wed Mar 24 1999 Matt Wilson <msw@redhat.com>
- added pam_console back into pam.d/login

* Tue Mar 23 1999 Matt Wilson <msw@redhat.com>
- updated to 2.9i
- added hwclock for sparcs and alpha

* Mon Mar 22 1999 Erik Troan <ewt@redhat.com>
- added vigr to file list

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 12)

* Thu Mar 18 1999 Cristian Gafton <gafton@redhat.com>
- remove most of the ifnarch arm stuff

* Mon Mar 15 1999 Michael Johnson <johnsonm@redhat.com>
- added pam_console.so to /etc/pam.d/login

* Thu Feb  4 1999 Michael K. Johnson <johnsonm@redhat.com>
- .perms patch to login to make it retain root in parent process
  for pam_close_session to work correctly

* Tue Jan 12 1999 Jeff Johnson <jbj@redhat.com>
- strip fdisk in buildroot correctly (#718)

* Mon Jan 11 1999 Cristian Gafton <gafton@redhat.com>
- have fdisk compiled on sparc and arm

* Mon Jan 11 1999 Erik Troan <ewt@redhat.com>
- added beos partition type to fdisk

* Wed Dec 30 1998 Cristian Gafton <gafton@redhat.com>
- incorporate fdisk on all arches

* Sat Dec  5 1998 Jeff Johnson <jbj@redhat.com>
- restore PAM functionality at end of login (Bug #201)

* Thu Dec 03 1998 Cristian Gafton <gafton@redhat.com>
- patch top build on the arm without PAM and related utilities, for now.
- build hwclock only on intel

* Wed Nov 18 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to version 2.9

* Thu Oct 29 1998 Bill Nottingham <notting@redhat.com>
- build for Raw Hide (slang-1.2.2)
- patch kbdrate wackiness so it builds with egcs

* Tue Oct 13 1998 Erik Troan <ewt@redhat.com>
- patched more to use termcap

* Mon Oct 12 1998 Erik Troan <ewt@redhat.com>
- added warning about alpha/bsd label starting cylinder

* Mon Sep 21 1998 Erik Troan <ewt@redhat.com>
- use sigsetjmp/siglongjmp in more rather then sig'less versions

* Fri Sep 11 1998 Jeff Johnson <jbj@redhat.com>
- explicit attrs for setuid/setgid programs

* Thu Aug 27 1998 Cristian Gafton <gafton@redhat.com>
- sln is now included in glibc

* Sun Aug 23 1998 Jeff Johnson <jbj@redhat.com>
- add cbm1581 floppy definitions (problem #787)

* Mon Jun 29 1998 Jeff Johnson <jbj@redhat.com>
- remove /etc/nologin at end of shutdown/halt.

* Fri Jun 19 1998 Jeff Johnson <jbj@redhat.com>
- add mount/losetup.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- update to 2.8 with 2.8b clean up. hostid now defunct?

* Mon Jun 01 1998 David S. Miller <davem@dm.cobaltmicro.com>
- "more" now works properly on sparc

* Sat May 02 1998 Jeff Johnson <jbj@redhat.com>
- Fix "fdisk -l" fault on mounted cdrom. (prob #513)

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sat Apr 11 1998 Cristian Gafton <gafton@redhat.com>
- manhattan rebuild

* Mon Dec 29 1997 Erik Troan <ewt@redhat.com>
- more didn't suspend properly on glibc
- use proper tc*() calls rather then ioctl's

* Sun Dec 21 1997 Cristian Gafton <gafton@redhat.com>
- fixed a security problem in chfn and chsh accepting too 
  long gecos fields

* Fri Dec 19 1997 Mike Wangsmo <wanger@redhat.com>
- removed "." from default path

* Tue Dec 02 1997 Cristian Gafton <gafton@redhat.com>
- added (again) the vipw patch

* Wed Oct 22 1997 Michael Fulbright <msf@redhat.com>
- minor cleanups for glibc 2.1

* Fri Oct 17 1997 Michael Fulbright <msf@redhat.com>
- added vfat32 filesystem type to list recognized by fdisk

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- don't build clock on the alpha 
- don't install chkdupexe

* Thu Oct 02 1997 Michael K. Johnson <johnsonm@redhat.com>
- Update to new pam standard.
- BuildRoot.

* Thu Sep 25 1997 Cristian Gafton <gafton@redhat.com>
- added rootok and setproctitle patches
- updated pam config files for chfn and chsh

* Tue Sep 02 1997 Erik Troan <ewt@redhat.com>
- updated MCONFIG to automatically determine the architecture
- added glibc header hacks to fdisk code
- rdev is only available on the intel

* Fri Jul 18 1997 Erik Troan <ewt@redhat.com>
- update to util-linux 2.7, fixed login problems

* Wed Jun 25 1997 Erik Troan <ewt@redhat.com>
- Merged Red Hat changes into main util-linux source, updated package to
  development util-linux (nearly 2.7).

* Tue Apr 22 1997 Michael K. Johnson <johnsonm@redhat.com>
- LOG_AUTH --> LOG_AUTHPRIV in login and shutdown

* Mon Mar 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved to new pam and from pam.conf to pam.d

* Tue Feb 25 1997 Michael K. Johnson <johnsonm@redhat.com>
- pam.patch differentiated between different kinds of bad logins.
  In particular, "user does not exist" and "bad password" were treated
  differently.  This was a minor security hole.
